xquery version "3.1";
(:~
 : Get bible analysis file names from github and present them as a list.
 :)

module namespace ba="https://sade.textgrid.de/ns/ba";

import module namespace functx="http://www.functx.com";

declare namespace http="http://expath.org/ns/http-client";


declare function ba:content($node as node(), $model as map(*))
{
let $request :=
    <http:request
        method="GET"
        href="https://api.github.com/repos/Bibliothek-der-Neologie/bdnBible/contents/output"
    >
        <http:header
            name="Accept"
            value="application/vnd.github.v3+json"
        />
    </http:request>

let $response := http:send-request($request)[2] => util:base64-decode() => json-to-xml()

return
    element ul {
        for $item in $response/fn:array/*
        return
            if (xs:int($item/fn:number[@key="size"]) > 0)
            then
                element li {
                    element a {
                        attribute href {
                            "bible-files?file=" || $item/fn:string[@key="html_url"]/string() => functx:substring-after-last("/")
                        },
                        $item/fn:string[@key="name"]/string()
                    }
                }
            else ()
    }
};
